#Blast Webservice (with PBSDispatcher and PBSInvocator)
#

def _toParameters(queryData):
    """shall return a command name, parameters
    """
    from bioMoby import MobyFASTA, Parameter
    import random, string, os

    parameters=[]
    commandName="blastpgp"
    tempfiles=[]
    outputfiles=[]

    tfs='tmp'+ `int(random.random()*1000000)`
    
    mandatory=[]

    for datum in queryData:
        if datum.__class__ is MobyFASTA:
            fp=file(tfs,"w")
            fp.write(datum.content)
            fp.close()
            parameters.append("-i "+tfs)
            mandatory.append("SEQ")
            tempfiles.append(tfs)
        if datum.__class__ is Parameter:
            parameters.append("-"+datum.articleName+" "+datum.value)

    if "SEQ" not in mandatory:
        for tf in tempfiles:
            try:
                os.remove(tf)
            except:
                pass
        raise Exception, "At least a sequence in FASTA format is needed"
        

    parameters.append("-o "+tfs+".res")
    outputfiles.append(tfs+".res")

    return (commandName, " ".join(parameters), tempfiles, outputfiles)

def LogFormatter(results):
    """Send the raw results
    """
    from bioMoby import MobyTextFormatted
    
    return [MobyTextFormatted(content=results)]

def blastpgp(mobyContent):
    from bioMoby import PBSDispatcher
    
    d=PBSDispatcher(mobyContent, toParameters, 'local',  ['nodes=1', 'local', 'ppn=1'], formatter=LogFormatter)
    
    return d.execute()

from ZSI import dispatch
from bioMoby.webservice import TCBioMoby
dispatch.asCGI(typesmodule=TCBioMoby)
